C-fpp- =================================================================
C-fpp- fpp -- C version 1.0.8 [06-Dec-1991]
C-fpp- Date: Fri Jan 31 07:47:45 1992
C-fpp- Directory: /home/plot79/sf3dir
C-fpp- User:  <beebe@eros>
C-fpp- Macro: _OS_UNIX=1
C-fpp- Macro: _MIPS=1
C-fpp- Macro: _BIG_ENDIAN=1
C-fpp- Macro: _IEEE_754=1
C-fpp- Macro: _NAMELIST=1
C-fpp- =================================================================
      SUBROUTINE  WRITLN (IOUNIT,LINE,NWORDS)
C     (Write Line)
C     Output "NWORDS" words of text  in "LINE(*)" to unit  number
C     "IOUNIT".   This  simple  operation   is  relegated  to   a
C     subroutine for three reasons:
C     1) an implied do can be avoided on the WRITE statement,
C        which is usually more efficient.
C     2) word-size dependence for the format is localized.
C     3) replacement by an assembly-language equivalent is
C        facilitated.
C     (01-Mar-1991)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       MOD
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             MOD
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     RUNTIME DIMENSION VARIABLES
C
      INTEGER             NWORDS
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                FF,          I
C
      INTEGER             FF,          I,           IOUNIT
      INTEGER             LINE(NWORDS)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM20  /
C
      INTEGER             HDRDAT,      HDRLEV,      HDRLMX,      HDRLNO
      INTEGER             HDRNAM,      HDRNUM,      HDRPNO,      HDRTIM
      INTEGER             HDRUNO,      HDRVER
      LOGICAL             HDRON
      COMMON / COM20  /   HDRDAT(5),   HDRLEV,      HDRLMX,      HDRLNO
      COMMON / COM20  /   HDRNAM(10),  HDRNUM,      HDRON,       HDRPNO
      COMMON / COM20  /   HDRTIM(5),   HDRUNO,      HDRVER
C
C
C#if _OS_VAXVMS
C##      INTEGER*2 NUMBER
C##      INTEGER   MODCNT
C##      INTEGER*2 LNO
C##      COMMON /LSEQ01/ LNO(0:99)
C#endif
C
C     Set FF = 12 for an ASCII form-feed when an "R1" format item
C     can be used,  and ASCII carriage  control is desired.   For
C     machines using normal  FORTRAN carriage control,  set FF  =
C     "1H1", and use an "A1" FORMAT item.
C
C#if _OS_VAXVMS
C##      DATA                FF        / 1H1 /
C##      SAVE                MODCNT
C##      DATA                MODCNT    / 0 /
C#else
      DATA                FF        / 12 /
C#endif
C
      IF (.NOT.(HDRON .AND. (HDRUNO .EQ. IOUNIT))) GO TO 20001
      HDRLNO = MOD(HDRLNO+1,HDRLMX)
      IF (.NOT.(HDRLNO .EQ. 0)) GO TO 20004
      WRITE (IOUNIT,1000) LINE
C#if _OS_TOPS20
C##                WRITE (IOUNIT,3000) HDRVER,HDRLEV,HDRDAT(1),
C##     *               HDRDAT(2),
C##     *               HDRTIM(1),(HDRNAM(I),I=1,5),HDRPNO,HDRNUM
C#else
      WRITE (IOUNIT,3000) HDRVER,HDRLEV,(HDRDAT(I),I=1,3),
     X(HDRTIM(I),I=1,2),(HDRNAM(I),I=1,6),HDRPNO,HDRNUM
C#endif
      GO TO 20005
20004 IF (.NOT.(HDRLNO .EQ. 1)) GO TO 10001
      HDRPNO = HDRPNO + 1
C#if _OS_TOPS20
C##                WRITE (IOUNIT,2000) FF,HDRVER,HDRLEV,HDRDAT(1),
C##     *               HDRDAT(2),HDRTIM(1),(HDRNAM(I),I=1,5),HDRPNO,
C##     *               HDRNUM
C#elif _OS_VAXVMS
C##                WRITE (IOUNIT,2000) FF,HDRVER,HDRLEV,(HDRDAT(I),I=1,3
C##     *               (HDRTIM(I),I=1,2),(HDRNAM(I),I=1,6),HDRPNO,HDRNU
C#else
      WRITE (IOUNIT,2000) CHAR(FF),
     XHDRVER,HDRLEV,(HDRDAT(I),I=1,3),
     X(HDRTIM(I),I=1,2),(HDRNAM(I),I=1,6),HDRPNO,HDRNUM
C#endif
      HDRLNO = 4
      WRITE (IOUNIT,1000) LINE
      GO TO 20005
10001 WRITE (IOUNIT,1000) LINE
20005 CONTINUE
20006 GO TO 20002
C#if _OS_VAXVMS
C##           IF (IOUNIT .EQ. OUTF4) THEN -- FORTRAN output
C##                DECODE(8,'(I8)',LINE(19)) NUMBER
C##                IF (NUMBER .EQ. 10) MODCNT = MODCNT + 1
C##                IF ((MODCNT .GT. 1) .AND. (NUMBER .EQ. 10)) THEN
C##     X               -- write pagemark
C##                     LNO(IOUNIT) = -1
C##                     WRITE (IOUNIT,'(A)') CHAR(12)
C##                END IF
C##                LNO(IOUNIT) = NUMBER
C##                WRITE (IOUNIT,1000) (LINE(I), I = 1,18)
C##           ELSE -- not FORTRAN file
C##                WRITE (IOUNIT,1000) LINE
C##           END IF
C#else
20001 WRITE (IOUNIT,1000) LINE
C#endif
20002 CONTINUE
C
20003 RETURN
C
C#if _OS_TOPS20
C## 1000 FORMAT (26A5)
C## 2000 FORMAT (R1,14HSFTRAN Version,I2,1H.,I2,1X,A5,A4, 1X,A5, 2X,5A5,
C##     X     1X, 5HPage ,I3,1H/,I2//)
C## 3000 FORMAT (//15H SFTRAN Version,I2,1H.,I2,1X,A5,A4, 1X,A5, 2X,5A5,
C##     X     1X, 5HPage ,I3,1H/,I2)
C#else
 1000 FORMAT (32A4,A2)
 2000 FORMAT (A1,14HSFTRAN Version,I2,1H.,I2, 1X,2A4,A1, 1X,A4,A1,
     X1X,6A4, 1X,5HPage ,I3,1H/,I2//)
 3000 FORMAT (//15H SFTRAN Version,I2,1H.,I2, 1X,2A4,A1, 1X,A4,A1,
     X1X,6A4, 1X,5HPage ,I3,1H/,I2)
C#endif
      END
